SystemOrganization addCategory: #PJT!
SystemOrganization addCategory: #'PJT-DependencyFinder'!
SystemOrganization addCategory: #'PJT-DependencyFinder-Test'!
SystemOrganization addCategory: #'PJT-Test'!
SystemOrganization addCategory: #'PJT-UI'!
SystemOrganization addCategory: #'PJT-UI-Test'!
SystemOrganization addCategory: #'PJT-Utilities'!
SystemOrganization addCategory: #'PJT-Utilities-Test'!

TestCase subclass: #BasicUITest
	instanceVariableNames: 'drawingPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-UI-Test'!

!BasicUITest methodsFor: 'as yet unclassified' stamp: 'RamonBespinyowong 4/16/2013 17:44'!
initialize 
	| packages dependencies p1 p2 df count|
	super initialize.
	drawingPanel := DrawingPanelMorph new width: 400; height: 300.
	"p1 := PjtPackage new packageName: #A.
	p2 := PjtPackage new packageName: #B.
	p3 := PjtPackage new packageName: #C.
	p4 := PjtPackage new packageName: #D.
	packages := Array with: p1 with: p2 with: p3 with: p4.
	
	dependencies := Array new: 4.
	dependencies at:1 put: (PjtDependency new from: p1 to: p2).
	dependencies at:2 put: (PjtDependency new from: p1 to: p3).
	dependencies at:3 put: (PjtDependency new from: p1 to: p4).
	dependencies at:4 put: (PjtDependency new from: p2 to: p4).
	drawingPanel setPackages: packages dependencies: dependencies. 
	drawingPanel openInWorld"
	
	df := DependencyFinder new.
	df addPackageName: 'MyPackageOne'.
	df addPackageName: 'MyPackageTwo'.
	
	p1:= PjtPackage new packageName: 'MyPackageOne' asSymbol.
	p2:= PjtPackage new packageName: 'MyPackageTwo' asSymbol.
	packages:= Array with: p1 with: p2.
	dependencies := OrderedCollection new.
	
	count := df getNumDependencyFromPackage: 'MyPackageOne' to: 'MyPackageTwo'.
	count = 0 ifFalse: [ dependencies add: (PjtDependency new from: p1 to: p2). ].
	
	count := df getNumDependencyFromPackage: 'MyPackageTwo' to: 'MyPackageOne'.
	count = 0 ifFalse: [dependencies add: (PjtDependency new from: p2 to: p1).].

	drawingPanel setPackages: packages dependencies: dependencies.
	drawingPanel openInWorld! !

!BasicUITest methodsFor: 'as yet unclassified' stamp: 'RS 3/30/2013 11:05'!
testSimple
	self assert: 1=1! !

TestCase subclass: #DependencyFinderTest
	instanceVariableNames: 'df'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-DependencyFinder-Test'!

!DependencyFinderTest methodsFor: 'as yet unclassified' stamp: 'RamonBespinyowong 4/15/2013 02:13'!
testDependencyFinder
	|count|
	df := DependencyFinder new.
	df addPackageName: 'MyPackageOne'.
	df addPackageName: 'MyPackageTwo'.
	count := df getNumDependencyFromPackage: 'MyPackageOne' to: 'MyPackageTwo'.
	self assert: 2 = count.
	count := df getNumDependencyFromPackage: 'MyPackageTwo' to: 'MyPackageOne'.
	self assert: 1 = count! !

TestCase subclass: #PackageVisualizerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-Test'!

!PackageVisualizerTest methodsFor: 'as yet unclassified' stamp: 'RamonBespinyowong 4/16/2013 18:02'!
testPackageVisualizer
	|pv|
	pv := PackageVisualizer new.
	pv addPackage: 'MyPackageOne';
		addPackage: 'MyPackageTwo';
		addPackage: 'MyPackageThree'.
	pv run! !

TestCase subclass: #PositionCalculatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-Utilities-Test'!

!PositionCalculatorTest methodsFor: 'as yet unclassified' stamp: 'RS 4/16/2013 02:31'!
testIsIntersectDown
	self assert: (PositionCalculator isIntersectDownPoint: 1@1 boxCenter: 0@(-5)   boxSize: 2@2).
	self assert: (PositionCalculator isIntersectDownPoint: 1@1 boxCenter: (-5)@(-5)   boxSize: 2@2) equals: false.
	self assert: (PositionCalculator isIntersectDownPoint: 1@1 boxCenter: (-5)@(-5)   boxSize: 1@2) equals: false.! !

!PositionCalculatorTest methodsFor: 'as yet unclassified' stamp: 'RS 4/16/2013 02:38'!
testIsIntersectLeft
	self assert: (PositionCalculator isIntersectLeftPoint: 1@1 boxCenter: 5@0   boxSize: 2@2).
	self assert: (PositionCalculator isIntersectLeftPoint: 0@5 boxCenter: 5@0   boxSize: 2@2).
	self assert: (PositionCalculator isIntersectLeftPoint: 0@5 boxCenter: 5@0   boxSize: 2@1) equals: false.! !

!PositionCalculatorTest methodsFor: 'as yet unclassified' stamp: 'RS 4/16/2013 02:39'!
testIsIntersectRight
	self assert: (PositionCalculator isIntersectRightPoint: 1@1 boxCenter: (-5)@0   boxSize: 2@2).
	self assert: (PositionCalculator isIntersectRightPoint: 0@5 boxCenter: (-5)@0   boxSize: 2@2).
	self assert: (PositionCalculator isIntersectRightPoint: 0@5 boxCenter: (-5)@0   boxSize: 2@1) equals: false.! !

!PositionCalculatorTest methodsFor: 'as yet unclassified' stamp: 'RS 4/16/2013 02:36'!
testIsIntersectUp
	self assert: (PositionCalculator isIntersectUpPoint: 1@1 boxCenter: 0@5   boxSize: 2@2).
	self assert: (PositionCalculator isIntersectUpPoint: 1@1 boxCenter: 5@5   boxSize: 2@2) equals: false.
	self assert: (PositionCalculator isIntersectUpPoint: 1@1 boxCenter: 5@5   boxSize: 1@2) equals: false.! !

PolygonMorph subclass: #DependencyMorph
	instanceVariableNames: 'fromMorph toMorph thickness doubleClickAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-UI'!

!DependencyMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 20:12'!
draw
	| headPosition tailPosition toCenter fromCenter |
	fromCenter := fromMorph position + ((fromMorph width / 2)@(fromMorph height / 2)).
	toCenter := toMorph position + ((toMorph width / 2)@(toMorph height / 2)).
	
	headPosition := PositionCalculator getIntersectOuterPoint: fromCenter 
		boxPosition: toMorph position  boxSize: ((toMorph width)@(toMorph height)).   
	
	tailPosition := PositionCalculator getIntersectOuterPoint: toCenter 
		boxPosition: fromMorph position  boxSize: ((fromMorph width)@(fromMorph height)).   
	
      self vertices: {tailPosition. headPosition} color: Color black borderWidth: thickness borderColor: Color black.
	self makeForwardArrow.
! !

!DependencyMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/7/2013 18:19'!
fromMorph
	^fromMorph ! !

!DependencyMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 20:16'!
fromMorph: fMorph toMorph: tMorph
	self fromMorph: fMorph toMorph: tMorph thickness: 2! !

!DependencyMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 20:15'!
fromMorph: fMorph toMorph: tMorph thickness: athickness
	fromMorph := fMorph.
	toMorph := tMorph.
	thickness := athickness.
	self draw! !

!DependencyMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 22:03'!
handleMouseDown: evt
	owner popupShowAutomatic ! !

!DependencyMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/7/2013 18:18'!
hash
	^(fromMorph package packageName , '_' , toMorph package packageName) hash.! !

!DependencyMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/7/2013 16:35'!
initialize 
	super initialize.! !

!DependencyMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/7/2013 18:19'!
toMorph 
	^toMorph ! !

Morph subclass: #DrawingPanelMorph
	instanceVariableNames: 'dependencyMorphs packageMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-UI'!

!DrawingPanelMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/7/2013 16:15'!
draw
	self drawPackages.
	self drawDependencies! !

!DrawingPanelMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/7/2013 17:47'!
drawDependencies
	dependencyMorphs do: [:d |
		self addMorph: d.
		d draw.]! !

!DrawingPanelMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 20:50'!
drawGridPackages
	| nextX nextY |
	nextX := 50.
	nextY := 50.
	packageMorphs do: [:p |
			"pkgMorph := PackageMorph new width: 50; height: 50; position: nextX@nextY ."
			self addMorph: p.
			p position: self position + (nextX@nextY).
			nextX >= 200
				ifTrue:[
					nextX := 50. nextY := nextY + 150]
				ifFalse:[
					nextX := nextX + 150 ].
		].! !

!DrawingPanelMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 20:58'!
drawPackages
	| nextX nextY rand |
	rand := Random new.
	packageMorphs do: [:p |
			nextX := rand next * 0.8 * self width.
			nextY := rand next * 0.8 * self height.
			"pkgMorph := PackageMorph new width: 50; height: 50; position: nextX@nextY ."
			self addMorph: p.
			p position: self position + (nextX@nextY)
		].! !

!DrawingPanelMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 20:36'!
getMaxWeight: aDependencies
	^aDependencies inject: 1 into: [:mx :d | mx max: d weight ]! !

!DrawingPanelMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 21:57'!
handleMouseDown: evt
	Transcript show: 'aaa'; cr! !

!DrawingPanelMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 21:58'!
handleMouseUp: evt
	Transcript show: 'bbb'; cr! !

!DrawingPanelMorph methodsFor: 'as yet unclassified' stamp: 'RS 3/30/2013 11:06'!
initialize
	super initialize.
	self color: Color gray! !

!DrawingPanelMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/16/2013 12:37'!
redraw
	dependencyMorphs do: [:dm |
		dm delete.
		dm draw.
		self addMorph: dm]! !

!DrawingPanelMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 20:45'!
setPackages: aPackages dependencies: aDependencies
	| fromMorph toMorph mx |
	
	packageMorphs := Dictionary new.
	dependencyMorphs := Set new.
	aPackages do: [:p | 
		packageMorphs at: p packageName put: ((PackageMorph new) package: p)].
	
	mx := self getMaxWeight: aDependencies.

	aDependencies do: [:d | 
		fromMorph := packageMorphs at: (d from packageName).
		toMorph := packageMorphs at: (d to packageName).
		dependencyMorphs add: (DependencyMorph new fromMorph: fromMorph toMorph: toMorph 
		thickness: 2 + ((d weight - 1) * 5 / mx))].
	self draw 
	! !

!DrawingPanelMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/7/2013 17:14'!
wantsDroppedMorph: aMorph event: anEvent
	Transcript show: 'dropped'; cr.
	^super wantsDroppedMorph: aMorph event: anEvent ! !

Morph subclass: #PackageMorph
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-UI'!

!PackageMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 19:59'!
initialize 
	super initialize.
	self color: Color white.
	self width: 100; height: 50.! !

!PackageMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/7/2013 18:04'!
package
	^package ! !

!PackageMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/2/2013 10:28'!
package: aPackage
	| nameMorph |
	package := aPackage.
	nameMorph := aPackage packageName asString asMorph.
	self addMorph: nameMorph.
	nameMorph position: self position + (0@0)! !

!PackageMorph methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 21:49'!
position: aPosition
	super position: aPosition.
	self owner redraw.
! !

Object subclass: #ClassInformation
	instanceVariableNames: 'packageName class dependencyDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-DependencyFinder'!

!ClassInformation commentStamp: '<historical>' prior: 0!
A ClassInformation class is a class that stores information about classes such as, a class name, its package name, and its dependency list

Instance Variables
packageName	a name of the package
class			a class object
dependencyDict	a dictionary containing dependencies.
!

!ClassInformation class methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/13/2013 23:47'!
class: aClass packageName: aString
	^self new class: aClass packageName: aString! !

!ClassInformation methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/14/2013 17:33'!
addDependencyTo: aClassName 
	dependencyDict
		at: aClassName  
		ifAbsent: [
			dependencyDict at: aClassName put: 0
			 ] .
		
	dependencyDict
		at: aClassName
		put: (dependencyDict at: aClassName)+1! !

!ClassInformation methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/14/2013 17:33'!
addDependencyTo: aClassName total: aNumber
	dependencyDict
		at: aClassName  
		ifAbsent: [
			dependencyDict at: aClassName put: 0
			 ] .
		
	dependencyDict
		at: aClassName
		put: (dependencyDict at: aClassName)+aNumber! !

!ClassInformation methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/13/2013 23:47'!
class: aClass packageName: aString
	class := aClass.
	packageName := aString! !

!ClassInformation methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/14/2013 17:34'!
dependencyDict
	^dependencyDict! !

!ClassInformation methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/14/2013 17:34'!
initialize
	dependencyDict := Dictionary new! !

!ClassInformation methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/13/2013 23:47'!
packageName
	^packageName! !

!ClassInformation methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/13/2013 23:48'!
storedClass
	^ class! !

!ClassInformation methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/15/2013 02:07'!
storedClassName
	^self storedClass asString! !

Object subclass: #ClassReferenceBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-DependencyFinder'!

!ClassReferenceBrowser commentStamp: '<historical>' prior: 0!
A ClassReferenceBrowser is a class for parsing string from 'allCallsOn' message to a dictionary of class reference

usage:
ClassReferenceBrowser findReferenceDictionaryOf: "aClass"

!

!ClassReferenceBrowser class methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/14/2013 17:04'!
findReferenceDictionaryOf: aClass
	| referenceCollection refClassName returnDictionary|
	returnDictionary := Dictionary new.
	
	referenceCollection := aClass allCallsOn.
	
	referenceCollection do: [:each |
		refClassName := self getClassNameFrom: (each fullName asString).
		returnDictionary 
			at: refClassName
			ifAbsent: [returnDictionary at: refClassName put: 0].
		returnDictionary 
			at: refClassName 
			put: (returnDictionary at:refClassName) + 1
		].
	
	^returnDictionary ! !

!ClassReferenceBrowser class methodsFor: 'private' stamp: 'RamonBespinyowong 4/14/2013 16:59'!
getClassNameFrom: aString
	| classString reachBracket |
	classString := String new.
	reachBracket := false.
	
	aString do: [:each | 
						(each asString = '>' ) ifTrue: [reachBracket := true].
						reachBracket=false ifTrue: [classString := classString, each asString ]].
					
	^classString
	
	
	! !

Object subclass: #DependencyFinder
	instanceVariableNames: 'packageCollection classInfoCollection hasComputedDependencies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-DependencyFinder'!

!DependencyFinder commentStamp: '<historical>' prior: 0!
A DependencyFinder class is a class for finding dependencies between classes and packages

usage:
refer to test

Instance Variables
!

!DependencyFinder methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/14/2013 16:09'!
addPackageName: aPackageName
	packageCollection add: aPackageName! !

!DependencyFinder methodsFor: 'private' stamp: 'RamonBespinyowong 4/14/2013 16:15'!
addingClassesFrom: aPackageName
	| aClassArray |
	aClassArray := (PackageBrowser classArrayOf:  aPackageName).
	aClassArray do:[:aClass | 
		classInfoCollection add: (ClassInformation  class: aClass packageName: aPackageName)]! !

!DependencyFinder methodsFor: 'private' stamp: 'RamonBespinyowong 4/14/2013 00:06'!
addingClassesToClassCollection
	packageCollection 
		do:[:aPackagename |
			self addingClassesFrom: aPackagename
			]! !

!DependencyFinder methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/14/2013 17:37'!
beginFindingDependency
	self addingClassesToClassCollection.
	self findingDependencies.
	hasComputedDependencies := true
	! !

!DependencyFinder methodsFor: 'private' stamp: 'RamonBespinyowong 4/14/2013 17:11'!
classInfoOf: aClassName 
	classInfoCollection do: [ :aClassInfo|
		(aClassInfo storedClass asString) = aClassName ifTrue: [^aClassInfo]].
	
	^ nil ! !

!DependencyFinder methodsFor: 'private' stamp: 'RamonBespinyowong 4/15/2013 02:15'!
findDependencyOf: aClassInfo
	|refDict anotherClassName numOccur anotherClassInfo|
	refDict := ClassReferenceBrowser findReferenceDictionaryOf: (aClassInfo storedClass).
	refDict associationsDo: [ :assoc | 
		anotherClassName := assoc key.
		numOccur := assoc value.
		anotherClassInfo := self classInfoOf: anotherClassName.
		anotherClassInfo isNil ifFalse: [
			anotherClassInfo addDependencyTo: aClassInfo storedClassName total: numOccur ] 
		]! !

!DependencyFinder methodsFor: 'private' stamp: 'RamonBespinyowong 4/14/2013 16:16'!
findingDependencies
	
	classInfoCollection do:[:aClassInformation |
		self findDependencyOf: aClassInformation]! !

!DependencyFinder methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/15/2013 02:14'!
getNumDependencyFromPackage: aPackageName to: anotherPackageName 
	|dependencyDict anotherClassInfo count|
	hasComputedDependencies = false ifTrue: [ 
		self beginFindingDependency  ].
	
	count := 0.
	
	classInfoCollection do: [ :aClassInfo |
		aClassInfo packageName = aPackageName ifTrue:[
			dependencyDict := aClassInfo dependencyDict.
			dependencyDict associationsDo: [ :assoc | 
				anotherClassInfo:= self classInfoOf: (assoc key).
				anotherClassInfo = nil ifFalse: [ 
					anotherClassInfo packageName = anotherPackageName ifTrue:[
						count := count+ assoc value
					] 
				]
			]
		] 
	].

	^count! !

!DependencyFinder methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/14/2013 17:37'!
initialize 
	packageCollection := OrderedCollection new.
	classInfoCollection := OrderedCollection new.
	hasComputedDependencies := false! !

!DependencyFinder methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/16/2013 17:30'!
packageCollection
	^packageCollection! !

Object subclass: #PackageBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-DependencyFinder'!

!PackageBrowser commentStamp: '<historical>' prior: 0!
A PackageBrowser class is a class for browsing package in the MonticelloBrowser

Instance Variables
!

!PackageBrowser class methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/14/2013 18:11'!
classArrayOf: aPackagename

	| index classArray | 
	
	index := self findPackageIndexOf: aPackagename.
	classArray := (MCWorkingCopy allManagers at:index) packageSet classes.
	
	^classArray! !

!PackageBrowser class methodsFor: 'private' stamp: 'RamonBespinyowong 4/14/2013 18:10'!
findPackageIndexOf: aPackageName
	|index managers|
	managers := MCWorkingCopy allManagers.
	
	index := 0.
	managers do: [:each |
		index := index+1.
		(each packageSet) packageName = aPackageName ifTrue: [^index]].
	
	^ self error: 'unable to find a package called ', aPackageName ! !

Object subclass: #PackageVisualizer
	instanceVariableNames: 'aDependencyFinder aUI'
	classVariableNames: 'height width'
	poolDictionaries: ''
	category: 'PJT'!

!PackageVisualizer methodsFor: 'as yet unclassified' stamp: 'RamonBespinyowong 4/16/2013 17:27'!
addPackage: aPackageName
	aDependencyFinder addPackageName: aPackageName! !

!PackageVisualizer methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 19:45'!
initialize
	aDependencyFinder := DependencyFinder new.
	aUI := DrawingPanelMorph new width: 800; height: 500.
	! !

!PackageVisualizer methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 19:57'!
run
	"setup UI"
	|packageNameList PjtPackageList dependencies|
	PjtPackageList := OrderedCollection new.
	
	aDependencyFinder beginFindingDependency.
	packageNameList := aDependencyFinder packageCollection.
	packageNameList do: [ :eachName |
		 PjtPackageList add: (PjtPackage new packageName: eachName asSymbol)].
	
	dependencies := OrderedCollection new.
	PjtPackageList do: [ :aPjtPackage |
		 PjtPackageList do: [ :anotherPjtPackage |
			aPjtPackage ~= anotherPjtPackage ifTrue: [ 
				(( aDependencyFinder 
					getNumDependencyFromPackage: aPjtPackage packageName 
					to: anotherPjtPackage packageName) >0) ifTrue: [ 
						dependencies add: (PjtDependency new from: aPjtPackage to: anotherPjtPackage weight: (aDependencyFinder getNumDependencyFromPackage: aPjtPackage packageName to: anotherPjtPackage packageName))] ] ]].
	
	aUI setPackages:PjtPackageList dependencies:dependencies.
	aUI openInWorld! !

Object subclass: #PjtDependency
	instanceVariableNames: 'from to weight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-Utilities'!

!PjtDependency methodsFor: 'as yet unclassified' stamp: 'RS 3/30/2013 10:42'!
from
	^from ! !

!PjtDependency methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 19:52'!
from: aPackageFrom to: aPackageTo
	from := aPackageFrom.
	to := aPackageTo.
	weight := 1! !

!PjtDependency methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 19:51'!
from: aPackageFrom to: aPackageTo weight: aWeight
	from := aPackageFrom.
	to := aPackageTo.
	weight := aWeight! !

!PjtDependency methodsFor: 'as yet unclassified' stamp: 'RS 3/30/2013 10:41'!
initialize 
	super initialize ! !

!PjtDependency methodsFor: 'as yet unclassified' stamp: 'RS 3/30/2013 10:42'!
to
	^to! !

!PjtDependency methodsFor: 'as yet unclassified' stamp: 'RS 4/20/2013 20:27'!
weight
	^weight! !

Object subclass: #PjtPackage
	instanceVariableNames: 'packageName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-Utilities'!

!PjtPackage methodsFor: 'as yet unclassified' stamp: 'RS 4/7/2013 18:08'!
= aPackage 
	^packageName = aPackage packageName ! !

!PjtPackage methodsFor: 'as yet unclassified' stamp: 'RS 3/30/2013 10:37'!
initialize 
	super initialize ! !

!PjtPackage methodsFor: 'as yet unclassified' stamp: 'RS 3/30/2013 12:25'!
packageName 
	^packageName  ! !

!PjtPackage methodsFor: 'as yet unclassified' stamp: 'RS 3/30/2013 12:26'!
packageName: aName
	packageName := aName! !

!PjtPackage methodsFor: 'as yet unclassified' stamp: 'RS 3/30/2013 12:24'!
testString
	^'abc'! !

Object subclass: #PositionCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PJT-Utilities'!

!PositionCalculator class methodsFor: 'as yet unclassified' stamp: 'RS 4/16/2013 02:30'!
getIntersectOuterPoint: aPoint boxPosition: aPosition boxSize: aSize
	| intersect dy dx aCenter |
	aCenter := aPosition + (aSize / 2).
	dy := aCenter y - aPoint y.
	dx := aCenter x - aPoint x.
	intersect := aCenter copy.
	
	(self isIntersectLeftPoint: aPoint boxCenter: aCenter boxSize: aSize) ifTrue: [
		intersect := intersect - ((aSize x / 2)@((dy / dx) * aSize x / 2))].
	
	(self isIntersectRightPoint: aPoint boxCenter: aCenter boxSize: aSize) ifTrue: [
		intersect := intersect + ((aSize x / 2)@((dy / dx) * aSize x / 2))].
	
	(self isIntersectUpPoint: aPoint boxCenter: aCenter boxSize: aSize) ifTrue: [
		intersect := intersect - (((dx / dy) * aSize y / 2)@(aSize y / 2))].
	
	(self isIntersectDownPoint: aPoint boxCenter: aCenter boxSize: aSize) ifTrue: [
		intersect := intersect + (((dx / dy) * aSize y / 2)@(aSize y / 2))].
	
	^intersect! !

!PositionCalculator class methodsFor: 'as yet unclassified' stamp: 'RS 4/16/2013 02:30'!
isIntersectDownPoint: aPoint boxCenter: aCenter boxSize: aSize
	^self isIntersectUpPoint: aCenter boxCenter: aPoint boxSize: aSize ! !

!PositionCalculator class methodsFor: 'as yet unclassified' stamp: 'RS 4/16/2013 02:30'!
isIntersectLeftPoint: aPoint boxCenter: aCenter boxSize: aSize
	| dy dx |
	dx := aCenter x - aPoint x.
	dy := aCenter y - aPoint y.
	dx <= 0 ifTrue: [^false].
	"also true is corner"
	^ (dy abs/ dx) <= (aSize y / aSize x)
	! !

!PositionCalculator class methodsFor: 'as yet unclassified' stamp: 'RS 4/16/2013 02:30'!
isIntersectRightPoint: aPoint boxCenter: aCenter boxSize: aSize
	^ self isIntersectLeftPoint: aCenter boxCenter: aPoint boxSize: aSize! !

!PositionCalculator class methodsFor: 'as yet unclassified' stamp: 'RS 4/16/2013 02:30'!
isIntersectUpPoint: aPoint boxCenter: aCenter boxSize: aSize
	| dy dx |
	dx := aCenter x - aPoint x.
	dy := aCenter y - aPoint y.
	dy <= 0 ifTrue: [^false].
	"false if corner"
	^ (dx abs/ dy) < (aSize x / aSize y)! !
